# Copyright (C) 2007-2014 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

FENCE_POWER_CONTROLLERS = (
	'fence_wti',
	'fence_apc',
	'fence_apc_snmp'
)

FENCE_OPTS = {
	'fence_apc':			'APC Power Device',
	'fence_apc_snmp':		'APC Power Device (SNMP interface)',
	'fence_wti':			'WTI Power Device',
	'fence_brocade':		'Brocade Switch',
	'fence_vixel':			'Vixel SAN Switch',
	'fence_gnbd':			'Global Network Block Device',
	'fence_sanbox2':		'QLogic SANBox2',
	'fence_bladecenter':	'IBM Blade Center',
	'fence_hpblade':		'HP BladeSystem',
	'fence_mcdata':			'McDATA SAN Switch',
	'fence_eaton_snmp':		'Eaton Network Power Controller (SNMP Interface)',
	'fence_emerson':		'Emerson Network Power Controller (SNMP Interface)',
	'fence_egenera':		'Egenera BladeFrame',
	'fence_bullpap':		'Bull PAP',
	'fence_xvm':			'xvm Virtual Machine Fencing',
	'fence_virt':			'fence_virt Virtual Machine Fencing',
	'fence_scsi':			'SCSI Reservation Fencing',
	'fence_mpath':			'Multipath Persistent Reservation Fencing',
	'fence_ilo':			'HP iLO Device',
	'fence_ilo2':			'HP iLO2 Device',
	'fence_ilo3':			'HP iLO3 Device',
	'fence_ilo4':			'HP iLO4 Device',
	'fence_ilo_moonshot':		'HP Moonshot iLO Device',
	'fence_ilo_ssh':		'HP iLO Device Over SSH',
	'fence_ilo3_ssh':		'HP iLO3 Device Over SSH',
	'fence_ilo4_ssh':		'HP iLO4 Device Over SSH',
	'fence_ipmilan':		'IPMI Lan',
	'fence_idrac':			'Dell iDRAC',
	'fence_imm':			'IBM Integrated Management Module',
	'fence_ipdu':			'IBM iPDU',
	'fence_kdump':			'Fence kdump',
	'fence_drac':			'Dell DRAC',
	'fence_drac5':			'Dell DRAC 5',
	'fence_rsa':			'IBM RSA II Device',
	'fence_rsb':			'Fujitsu Siemens RemoteView Service Board',
	'fence_rps10':			'RPS10 Serial Switch',
	'fence_lpar':			'LPAR Fencing',
	'fence_vmware':			'VMware Fencing',
	'fence_vmware_soap':	'VMware Fencing (SOAP Interface)',
	'fence_manual':			'Manual Fencing',
	'fence_alom':			'Sun ALOM',
	'fence_rackswitch':		'RackSaver RackSwitch',
	'fence_zvm':			's390 z/VM',
	'fence_intelmodular':	'Intel Modular',
	'fence_ldom':			'Sun LDOM',
	'fence_cisco_mds':		'Cisco MDS',
	'fence_cisco_ucs':		'Cisco UCS',
	'fence_xcat':			'xCAT',
	'fence_cpint':			's390 cpint',
	'fence_ifmib':			'IF MIB',
	'fence_ilo_mp':			'HP iLO MP',
	'fence_eps':			'ePowerSwitch',
	'fence_virsh':			'virsh fence agent',
	'fence_rhevm':			'RHEV-M fence agent',
	'fence_sanlock':		'Sanlock fencing (watchdog and shared storage leases)',
}

FENCE_SHARED = {
	'fence_apc':			True,
	'fence_apc_snmp':		True,
	'fence_wti':			True,
	'fence_brocade':		True,
	'fence_vixel':			True,
	'fence_gnbd':			True,
	'fence_sanbox2':		True,
	'fence_bladecenter':	True,
	'fence_mcdata':			True,
	'fence_egenera':		True,
	'fence_bullpap':		True,
	'fence_xvm':			True,
	'fence_virt':			True,
	'fence_scsi':			True,
	'fence_mpath':			True,
	'fence_lpar':			True,
	'fence_vmware':			True,
	'fence_vmware_soap':	True,
	'fence_ldom':			True,
	'fence_rackswitch':		True,
	'fence_cisco_mds':		True,
	'fence_cisco_ucs':		True,
	'fence_eps':			True,
	'fence_ibmblade':		True,
	'fence_hpblade':		True,
	'fence_eaton_snmp':		True,
	'fence_emerson':		True,
	'fence_ifmib':			True,
	'fence_ipdu':			True,
	'fence_intelmodular':	True,
	'fence_virsh':			True,
	'fence_rhevm':			True,
	'fence_sanlock':		True,
	'fence_ilo':			False,
	'fence_ilo2':			False,
	'fence_ilo3':			False,
	'fence_ilo4':			False,
	'fence_ilo_moonshot':		False,
	'fence_ilo_ssh':		False,
	'fence_ilo3_ssh':		False,
	'fence_ilo4_ssh':		False,
	'fence_ilo_mp':			False,
	'fence_ipmilan':		False,
	'fence_idrac':			False,
	'fence_imm':			False,
	'fence_kdump':			False,
	'fence_drac':			False,
	'fence_drac5':			False,
	'fence_rps10':			False,
	'fence_rsa':			False,
	'fence_rsb':			False,
	'fence_xcat':			False,
	'fence_zvm':			False,
	'fence_alom':			False,
	'fence_cpint':			False,
	'fence_manual':			False
}
