# Copyright (C) 2006-2014 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from BaseResource import BaseResource
from gettext import gettext as _

TAG_NAME = 'nfsclient'
RESOURCE_TYPE = _('NFS Client')

DENY_ALL_CHILDREN = True

class NFSClient(BaseResource):
  def __init__(self):
    BaseResource.__init__(self)
    self.TAG_NAME = TAG_NAME
    self.resource_type = RESOURCE_TYPE
    self.deny_all_children = DENY_ALL_CHILDREN

  def SanityCheck(self):
    # Must be a child of some nfsexport or nfsserver
    found_export = False
    parent = self
    while True:
        parent = parent.getParent()
        if not parent:
            break
        parent_type = parent.getTagName()
        if parent_type in ('nfsexport', 'nfsserver'):
            found_export = True
            break

    if not found_export:
        raise Exception, '%s resources must have a parent nfsexport or nfsserver resource' % self.getTagName()
