/*
 * Shared JS functions.
 *
 */

function input_to_xml(elem) {
    var cur_xml_str = "";
    if ($(elem).attr('type') == 'checkbox') {
        if ($(elem).is(':checked')) {
            cur_xml_str += '<input name="' + $(elem).attr('name') + '" checked="checked" value="1" type="checkbox"/>';
        }
    } else {
        var cur_ival = $(elem).val();
        if (cur_ival) {
            cur_xml_str += '<input name="' + $(elem).attr('name') + '" value="' + Encoder.htmlEncode(cur_ival, true) + '" type="' + $(elem).attr('type') + '"/>';
        }
    }
    return cur_xml_str;
}

function update_multi_action(checkbox_obj) {
    if (!checkbox_obj || !checkbox_obj.form) {
        return;
    }
    var cur_form = $(checkbox_obj.form);
    var maction_buttons = $('.MultiAction', cur_form);
    var maction_items = $('.MultiActionItem', cur_form);

    if (checkbox_obj.checked !== false) {
        maction_buttons.removeAttr('disabled', 'disabled');
    } else {
        if ($(':checked', maction_items).length == 0) {
            maction_buttons.attr('disabled', 'disabled');
        }
    }
}

function reset_form(form_elem) {
    $(form_elem).each(function() {
        /* From jquery.form.js */
        if (typeof this.reset == 'function' || (typeof this.reset == 'object' && !this.reset.nodeType)) {
            this.reset();
        }

        $('select', this).each(function() {
            try {
                $(this).change();
            } catch (e) {}
        });
    });
}

function reset_service_form(form_elem) {
    reset_form(form_elem);
    try {
        $('#svc_root').empty();
    } catch (e) {}
}
