/*
 * JS functions specific for adding/quering nodes
 */


/* synchronous */

function allPasswdsSame(checkbox_obj) {
    if ($(checkbox_obj).is(':checked')) {
        var pw_elem = $('input:password', $(checkbox_obj.form));
        $.each(pw_elem, function() {
            var cur_val = $(this).val();
            if (cur_val) {
                $(pw_elem).val(cur_val);
                return false;
            }
        });
    }
}

function add_system_row(form) {
    var new_elem = $('#system_row_elem').clone();
    var input_elems = $(':input', $(new_elem));
    var num_nodes = Number(form.num_nodes.value) + 1;
    form.num_nodes.value = num_nodes;
    var new_id = $(form).attr('name') + '_system_row_elem' + num_nodes;
    $(new_elem).attr('id', new_id);
    $(input_elems).attr('name',
        function() { return this.name + num_nodes; });
    var img_elem = $('img', $(new_elem));
    $(img_elem).click(function() {
        $('#' + new_id + ', #systeminfo_row_elem' + num_nodes).remove();
    });
    $('table.clusternodes tr', $(form)).not('.add_node_button_row')
        .filter(':last').after($(new_elem));
    if ($(form.allSameCheckBox).is(':checked')) {
        allPasswdsSame(form.allSameCheckBox);
    }
}

function update_node_hostname(form_elem) {
    var host_number = form_elem.name.substr(8);
    var rh_elem = $(':input[name="riccihost' + host_number + '"]', $(form_elem.form));
    if (!$(rh_elem).val()) {
        $(rh_elem).val(form_elem.value).change();
    }
}


/* asynchronous */

function get_sysinfo_async(rowelemset) {
    if (!rowelemset.length)
        return;

    var submit = $( 'input[type="submit"]', rowelemset[0].parentElement.parentElement );
    if (submit)
            submit.attr('disabled', 'disabled');
    var out_data = {};
    rowelemset.each(function(index) {
        var hostname, port;
        /* riccihostX, nodeX_riccihost, hostnameX, nodeXhost */
        hostname = $( 'input[name^="riccihost"],'
                      + 'input[name$="riccihost"]', this );
        hostname = hostname.length
                   ? hostname
                   : $( 'input[name^="hostname"],'
                        + 'input[name$="host"]', this );
        hostname = hostname.attr("value");
        /* portX */
        port = $( 'input[name^="port"]', this ).attr("value");

        out_data[index] = hostname + '@' + port;
    });

    $.post('/async/get_system_info', out_data, function (in_data) {
        rowelemset.each(function(index) {
            var colspan = $( "td", this ).length;
            var sysinfo = $(this).next( 'tr.systeminfo' );
            var content = '';
            var pairindex = $(this).attr('id').match(/\d+$/)[0];

            if (in_data[index]['errors']) {
                if (out_data[index].lastIndexOf('@', 0) === 0) {
                    if (sysinfo.length) {
                        sysinfo.click();
                    }
                    return true;
                }
                content = '<span onclick="event.stopPropagation();">'
                          + '<em>errors getting certificate fingerprint</em>:';
                $.each(in_data[index]['errors'], function(i, val) {
                    content += '</span><br/><span onclick="event.stopPropagation();">' + val;
                });
                content += '</span>';
            } else {
                var digest = in_data['__digest__'] || '(undefined)';
                var seps = [];
                var val;
                switch (digest) {
                    /* put the break indices in reverse order */
                    case 'sha256': seps.push(48); break;
                }
                content = in_data[index]['fp'];
                $.each(seps, function(i, val) {
                    content = content.substring(0, val)
                              + '<br/><span onclick="event.stopPropagation();">'
                              + content.substring(val) + '</span>';
                });
                val = (seps.length) ? seps[seps.length - 1] : content.length;
                content = '<span onclick="event.stopPropagation();"><em>' + digest
                          + ' certificate fingerprint</em>:</span><br/>'
                          + '<span onclick="event.stopPropagation();">'
                          + content.substring(0, val)
                          + '</span>' + content.substring(val);
            }
            sysinfo = sysinfo.length
                    ? sysinfo
                    : $( '<tr class="systeminfo"'
                        + ' id="systeminfo_row_elem' + pairindex + '"'
                        + ' onclick="$(this).fadeOut(complete=function() {$(this).remove();});">'
                        + '<td colspan="' + colspan + '">'
                        + '<div class="systeminfo_frame silver"/></td></tr>' )
                      .insertAfter(this);
            $( "div.systeminfo_frame", sysinfo[0] ).hide()
                                                   .html(content).fadeIn();
        });
    }, 'json');
}
